## this file will read the proteinprophet result file "interact.prot.xml"
## and extract the nsp_adjusted_probability for each peptide.

peptide_list = {}
File.foreach("interact.prot.xml") { |each_line|
	read_str = each_line.strip
	
	if read_str =~ /<peptide peptide_sequence/
		# obtain peptide sequence
		read_str =~ /peptide_sequence="(.*?)"/
		peptide_seq = $1
		# obtain nsp_adjusted_probability
		read_str =~ /nsp_adjusted_probability="(.*?)"/
		probability = $1.to_f
		
		if peptide_list.has_key?(peptide_seq) == true
			if peptide_list[peptide_seq] < probability
				peptide_list[peptide_seq] = probability
			end
		else
			peptide_list[peptide_seq] = probability
		end
	end
}

adjusted_x_tandem_res = []
File.foreach("xtandem_identified_list.txt") { |each_line|
	read_str = each_line.strip
	
	# skip the first line
	if read_str =~ /Hyperscore/
		next
	end
	
	str_list = read_str.split("\t")
	peptide_name = str_list[5]
	if peptide_list.has_key?(peptide_name) == true
		adjusted_x_tandem_res << [peptide_name, str_list[1], peptide_list[peptide_name]]
	else
		adjusted_x_tandem_res << [peptide_name, str_list[1], 0.0]
	end
}

sorted_list = adjusted_x_tandem_res.sort { |a, b| b[2] <=> a[2]}

num_of_hit = []
fdr_list = []
hit_count = 0
decoy_count = 0
		
sorted_list.each { |each_item|
	hit_count += 1
	if each_item[1] == "Decoy"
		decoy_count += 1
	end
	
	fdr_est = 2.0 * decoy_count.to_f / hit_count.to_f
			
	num_of_hit << hit_count
	fdr_list << fdr_est
}


# estimate q-value
# the minimal fdr threshold at which a given PSM is
# accepted.
# Please refer to Assigning Significance to Peptides Identified by Tandem
# Mass Spectrometry Using Decoy Databases, JPR, 2007
q_value_list = Array.new(fdr_list.length, 0)
for loop_index in 0..(fdr_list.length - 1)
	sub_list = fdr_list[loop_index..(fdr_list.length - 1)].sort
	q_value_list[loop_index] = sub_list[0]
end

file_writer = File.open("nsp_adjusted.txt", 'w')
for save_index in 0..(q_value_list.length - 1)
	save_str = q_value_list[save_index].to_s + "," + num_of_hit[save_index].to_s
	file_writer.puts(save_str)
end
file_writer.close